<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCurrencyConversion ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCurrencyConversion
 * @subpackage Arrays
 */
class ArrayOfCurrencyConversion extends AbstractStructArrayBase
{
    /**
     * The CurrencyConversion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CurrencyConversion[]
     */
    public $CurrencyConversion;
    /**
     * Constructor method for ArrayOfCurrencyConversion
     * @uses ArrayOfCurrencyConversion::setCurrencyConversion()
     * @param \StructType\CurrencyConversion[] $currencyConversion
     */
    public function __construct(array $currencyConversion = array())
    {
        $this
            ->setCurrencyConversion($currencyConversion);
    }
    /**
     * Get CurrencyConversion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CurrencyConversion[]|null
     */
    public function getCurrencyConversion()
    {
        return isset($this->CurrencyConversion) ? $this->CurrencyConversion : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCurrencyConversion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCurrencyConversion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCurrencyConversionForArrayConstraintsFromSetCurrencyConversion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCurrencyConversionCurrencyConversionItem) {
            // validation for constraint: itemType
            if (!$arrayOfCurrencyConversionCurrencyConversionItem instanceof \StructType\CurrencyConversion) {
                $invalidValues[] = is_object($arrayOfCurrencyConversionCurrencyConversionItem) ? get_class($arrayOfCurrencyConversionCurrencyConversionItem) : sprintf('%s(%s)', gettype($arrayOfCurrencyConversionCurrencyConversionItem), var_export($arrayOfCurrencyConversionCurrencyConversionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CurrencyConversion property can only contain items of type \StructType\CurrencyConversion, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CurrencyConversion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CurrencyConversion[] $currencyConversion
     * @return \ArrayType\ArrayOfCurrencyConversion
     */
    public function setCurrencyConversion(array $currencyConversion = array())
    {
        // validation for constraint: array
        if ('' !== ($currencyConversionArrayErrorMessage = self::validateCurrencyConversionForArrayConstraintsFromSetCurrencyConversion($currencyConversion))) {
            throw new \InvalidArgumentException($currencyConversionArrayErrorMessage, __LINE__);
        }
        if (is_null($currencyConversion) || (is_array($currencyConversion) && empty($currencyConversion))) {
            unset($this->CurrencyConversion);
        } else {
            $this->CurrencyConversion = $currencyConversion;
        }
        return $this;
    }
    /**
     * Add item to CurrencyConversion value
     * @throws \InvalidArgumentException
     * @param \StructType\CurrencyConversion $item
     * @return \ArrayType\ArrayOfCurrencyConversion
     */
    public function addToCurrencyConversion(\StructType\CurrencyConversion $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CurrencyConversion) {
            throw new \InvalidArgumentException(sprintf('The CurrencyConversion property can only contain items of type \StructType\CurrencyConversion, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CurrencyConversion[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CurrencyConversion|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CurrencyConversion|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CurrencyConversion|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CurrencyConversion|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CurrencyConversion|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CurrencyConversion
     */
    public function getAttributeName()
    {
        return 'CurrencyConversion';
    }
}
