<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInsertExternalProcessedPayment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfInsertExternalProcessedPayment
 * @subpackage Arrays
 */
class ArrayOfInsertExternalProcessedPayment extends AbstractStructArrayBase
{
    /**
     * The InsertExternalProcessedPayment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InsertExternalProcessedPayment[]
     */
    public $InsertExternalProcessedPayment;
    /**
     * Constructor method for ArrayOfInsertExternalProcessedPayment
     * @uses ArrayOfInsertExternalProcessedPayment::setInsertExternalProcessedPayment()
     * @param \StructType\InsertExternalProcessedPayment[] $insertExternalProcessedPayment
     */
    public function __construct(array $insertExternalProcessedPayment = array())
    {
        $this
            ->setInsertExternalProcessedPayment($insertExternalProcessedPayment);
    }
    /**
     * Get InsertExternalProcessedPayment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InsertExternalProcessedPayment[]|null
     */
    public function getInsertExternalProcessedPayment()
    {
        return isset($this->InsertExternalProcessedPayment) ? $this->InsertExternalProcessedPayment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInsertExternalProcessedPayment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInsertExternalProcessedPayment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInsertExternalProcessedPaymentForArrayConstraintsFromSetInsertExternalProcessedPayment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInsertExternalProcessedPaymentInsertExternalProcessedPaymentItem) {
            // validation for constraint: itemType
            if (!$arrayOfInsertExternalProcessedPaymentInsertExternalProcessedPaymentItem instanceof \StructType\InsertExternalProcessedPayment) {
                $invalidValues[] = is_object($arrayOfInsertExternalProcessedPaymentInsertExternalProcessedPaymentItem) ? get_class($arrayOfInsertExternalProcessedPaymentInsertExternalProcessedPaymentItem) : sprintf('%s(%s)', gettype($arrayOfInsertExternalProcessedPaymentInsertExternalProcessedPaymentItem), var_export($arrayOfInsertExternalProcessedPaymentInsertExternalProcessedPaymentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InsertExternalProcessedPayment property can only contain items of type \StructType\InsertExternalProcessedPayment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InsertExternalProcessedPayment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InsertExternalProcessedPayment[] $insertExternalProcessedPayment
     * @return \ArrayType\ArrayOfInsertExternalProcessedPayment
     */
    public function setInsertExternalProcessedPayment(array $insertExternalProcessedPayment = array())
    {
        // validation for constraint: array
        if ('' !== ($insertExternalProcessedPaymentArrayErrorMessage = self::validateInsertExternalProcessedPaymentForArrayConstraintsFromSetInsertExternalProcessedPayment($insertExternalProcessedPayment))) {
            throw new \InvalidArgumentException($insertExternalProcessedPaymentArrayErrorMessage, __LINE__);
        }
        if (is_null($insertExternalProcessedPayment) || (is_array($insertExternalProcessedPayment) && empty($insertExternalProcessedPayment))) {
            unset($this->InsertExternalProcessedPayment);
        } else {
            $this->InsertExternalProcessedPayment = $insertExternalProcessedPayment;
        }
        return $this;
    }
    /**
     * Add item to InsertExternalProcessedPayment value
     * @throws \InvalidArgumentException
     * @param \StructType\InsertExternalProcessedPayment $item
     * @return \ArrayType\ArrayOfInsertExternalProcessedPayment
     */
    public function addToInsertExternalProcessedPayment(\StructType\InsertExternalProcessedPayment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InsertExternalProcessedPayment) {
            throw new \InvalidArgumentException(sprintf('The InsertExternalProcessedPayment property can only contain items of type \StructType\InsertExternalProcessedPayment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InsertExternalProcessedPayment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InsertExternalProcessedPayment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InsertExternalProcessedPayment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InsertExternalProcessedPayment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InsertExternalProcessedPayment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InsertExternalProcessedPayment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InsertExternalProcessedPayment
     */
    public function getAttributeName()
    {
        return 'InsertExternalProcessedPayment';
    }
}
