<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProcessItemPayment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProcessItemPayment
 * @subpackage Arrays
 */
class ArrayOfProcessItemPayment extends AbstractStructArrayBase
{
    /**
     * The ProcessItemPayment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProcessItemPayment[]
     */
    public $ProcessItemPayment;
    /**
     * Constructor method for ArrayOfProcessItemPayment
     * @uses ArrayOfProcessItemPayment::setProcessItemPayment()
     * @param \StructType\ProcessItemPayment[] $processItemPayment
     */
    public function __construct(array $processItemPayment = array())
    {
        $this
            ->setProcessItemPayment($processItemPayment);
    }
    /**
     * Get ProcessItemPayment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProcessItemPayment[]|null
     */
    public function getProcessItemPayment()
    {
        return isset($this->ProcessItemPayment) ? $this->ProcessItemPayment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProcessItemPayment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProcessItemPayment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProcessItemPaymentForArrayConstraintsFromSetProcessItemPayment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProcessItemPaymentProcessItemPaymentItem) {
            // validation for constraint: itemType
            if (!$arrayOfProcessItemPaymentProcessItemPaymentItem instanceof \StructType\ProcessItemPayment) {
                $invalidValues[] = is_object($arrayOfProcessItemPaymentProcessItemPaymentItem) ? get_class($arrayOfProcessItemPaymentProcessItemPaymentItem) : sprintf('%s(%s)', gettype($arrayOfProcessItemPaymentProcessItemPaymentItem), var_export($arrayOfProcessItemPaymentProcessItemPaymentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProcessItemPayment property can only contain items of type \StructType\ProcessItemPayment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProcessItemPayment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProcessItemPayment[] $processItemPayment
     * @return \ArrayType\ArrayOfProcessItemPayment
     */
    public function setProcessItemPayment(array $processItemPayment = array())
    {
        // validation for constraint: array
        if ('' !== ($processItemPaymentArrayErrorMessage = self::validateProcessItemPaymentForArrayConstraintsFromSetProcessItemPayment($processItemPayment))) {
            throw new \InvalidArgumentException($processItemPaymentArrayErrorMessage, __LINE__);
        }
        if (is_null($processItemPayment) || (is_array($processItemPayment) && empty($processItemPayment))) {
            unset($this->ProcessItemPayment);
        } else {
            $this->ProcessItemPayment = $processItemPayment;
        }
        return $this;
    }
    /**
     * Add item to ProcessItemPayment value
     * @throws \InvalidArgumentException
     * @param \StructType\ProcessItemPayment $item
     * @return \ArrayType\ArrayOfProcessItemPayment
     */
    public function addToProcessItemPayment(\StructType\ProcessItemPayment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProcessItemPayment) {
            throw new \InvalidArgumentException(sprintf('The ProcessItemPayment property can only contain items of type \StructType\ProcessItemPayment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProcessItemPayment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProcessItemPayment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProcessItemPayment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProcessItemPayment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProcessItemPayment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProcessItemPayment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProcessItemPayment
     */
    public function getAttributeName()
    {
        return 'ProcessItemPayment';
    }
}
