<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProcessPNRPayment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProcessPNRPayment
 * @subpackage Arrays
 */
class ArrayOfProcessPNRPayment extends AbstractStructArrayBase
{
    /**
     * The ProcessPNRPayment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProcessPNRPayment[]
     */
    public $ProcessPNRPayment;
    /**
     * Constructor method for ArrayOfProcessPNRPayment
     * @uses ArrayOfProcessPNRPayment::setProcessPNRPayment()
     * @param \StructType\ProcessPNRPayment[] $processPNRPayment
     */
    public function __construct(array $processPNRPayment = array())
    {
        $this
            ->setProcessPNRPayment($processPNRPayment);
    }
    /**
     * Get ProcessPNRPayment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProcessPNRPayment[]|null
     */
    public function getProcessPNRPayment()
    {
        return isset($this->ProcessPNRPayment) ? $this->ProcessPNRPayment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProcessPNRPayment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProcessPNRPayment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProcessPNRPaymentForArrayConstraintsFromSetProcessPNRPayment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProcessPNRPaymentProcessPNRPaymentItem) {
            // validation for constraint: itemType
            if (!$arrayOfProcessPNRPaymentProcessPNRPaymentItem instanceof \StructType\ProcessPNRPayment) {
                $invalidValues[] = is_object($arrayOfProcessPNRPaymentProcessPNRPaymentItem) ? get_class($arrayOfProcessPNRPaymentProcessPNRPaymentItem) : sprintf('%s(%s)', gettype($arrayOfProcessPNRPaymentProcessPNRPaymentItem), var_export($arrayOfProcessPNRPaymentProcessPNRPaymentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProcessPNRPayment property can only contain items of type \StructType\ProcessPNRPayment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProcessPNRPayment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProcessPNRPayment[] $processPNRPayment
     * @return \ArrayType\ArrayOfProcessPNRPayment
     */
    public function setProcessPNRPayment(array $processPNRPayment = array())
    {
        // validation for constraint: array
        if ('' !== ($processPNRPaymentArrayErrorMessage = self::validateProcessPNRPaymentForArrayConstraintsFromSetProcessPNRPayment($processPNRPayment))) {
            throw new \InvalidArgumentException($processPNRPaymentArrayErrorMessage, __LINE__);
        }
        if (is_null($processPNRPayment) || (is_array($processPNRPayment) && empty($processPNRPayment))) {
            unset($this->ProcessPNRPayment);
        } else {
            $this->ProcessPNRPayment = $processPNRPayment;
        }
        return $this;
    }
    /**
     * Add item to ProcessPNRPayment value
     * @throws \InvalidArgumentException
     * @param \StructType\ProcessPNRPayment $item
     * @return \ArrayType\ArrayOfProcessPNRPayment
     */
    public function addToProcessPNRPayment(\StructType\ProcessPNRPayment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProcessPNRPayment) {
            throw new \InvalidArgumentException(sprintf('The ProcessPNRPayment property can only contain items of type \StructType\ProcessPNRPayment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProcessPNRPayment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProcessPNRPayment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProcessPNRPayment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProcessPNRPayment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProcessPNRPayment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProcessPNRPayment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProcessPNRPayment
     */
    public function getAttributeName()
    {
        return 'ProcessPNRPayment';
    }
}
