<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ProcessPNRPayment' => '\\StructType\\ProcessPNRPayment',
            'ProcessPNRPaymentResponse' => '\\StructType\\ProcessPNRPaymentResponse',
            'ProcessItemPayment' => '\\StructType\\ProcessItemPayment',
            'ProcessItemPaymentResponse' => '\\StructType\\ProcessItemPaymentResponse',
            'InsertExternalProcessedPayment' => '\\StructType\\InsertExternalProcessedPayment',
            'InsertExternalProcessedPaymentResponse' => '\\StructType\\InsertExternalProcessedPaymentResponse',
            'Format3DSecureInformation' => '\\StructType\\Format3DSecureInformation',
            'Format3DSecureInformationResponse' => '\\StructType\\Format3DSecureInformationResponse',
            'UpdateExternalProcessedPayment' => '\\StructType\\UpdateExternalProcessedPayment',
            'UpdateExternalProcessedPaymentResponse' => '\\StructType\\UpdateExternalProcessedPaymentResponse',
            'ConvertCurrencies' => '\\StructType\\ConvertCurrencies',
            'ConvertCurrenciesResponse' => '\\StructType\\ConvertCurrenciesResponse',
            'UpdateTicketingTimeLimit' => '\\StructType\\UpdateTicketingTimeLimit',
            'UpdateTicketingTimeLimitResponse' => '\\StructType\\UpdateTicketingTimeLimitResponse',
            'AddVoucherToReservation' => '\\StructType\\AddVoucherToReservation',
            'AddVoucherToReservationResponse' => '\\StructType\\AddVoucherToReservationResponse',
            'UpdateExternalProcessedPaymentDetails' => '\\StructType\\UpdateExternalProcessedPaymentDetails',
            'UpdateExternalProcessedPaymentDetailsResponse' => '\\StructType\\UpdateExternalProcessedPaymentDetailsResponse',
            'RemoveVoucherFromReservationInSession' => '\\StructType\\RemoveVoucherFromReservationInSession',
            'RemoveVoucherFromReservationInSessionResponse' => '\\StructType\\RemoveVoucherFromReservationInSessionResponse',
            'GetConvertedReservationBalance' => '\\StructType\\GetConvertedReservationBalance',
            'GetConvertedReservationBalanceResponse' => '\\StructType\\GetConvertedReservationBalanceResponse',
            'AddPointsToReservation' => '\\StructType\\AddPointsToReservation',
            'AddPointsToReservationResponse' => '\\StructType\\AddPointsToReservationResponse',
            'PNRPayments' => '\\StructType\\PNRPayments',
            'ArrayOfProcessPNRPayment' => '\\ArrayType\\ArrayOfProcessPNRPayment',
            'Payment' => '\\StructType\\Payment',
            'ItemPayments' => '\\StructType\\ItemPayments',
            'ArrayOfProcessItemPayment' => '\\ArrayType\\ArrayOfProcessItemPayment',
            'ExternalProcessedPayments' => '\\StructType\\ExternalProcessedPayments',
            'ArrayOfInsertExternalProcessedPayment' => '\\ArrayType\\ArrayOfInsertExternalProcessedPayment',
            'CurrencyConversionList' => '\\StructType\\CurrencyConversionList',
            'ArrayOfCurrencyConversion' => '\\ArrayType\\ArrayOfCurrencyConversion',
            'CurrencyConversion' => '\\StructType\\CurrencyConversion',
            'PaymentDetails' => '\\StructType\\PaymentDetails',
            'RemoveVoucherFromReservationInSessionRQ' => '\\StructType\\RemoveVoucherFromReservationInSessionRQ',
            'GetConvertedReservationBalanceRequest' => '\\StructType\\GetConvertedReservationBalanceRequest',
            'PointsPayments' => '\\StructType\\PointsPayments',
            'ArrayOfAddPointsPayment' => '\\ArrayType\\ArrayOfAddPointsPayment',
            'AddPointsPayment' => '\\StructType\\AddPointsPayment',
            'TransactionInfo' => '\\StructType\\TransactionInfo',
            'ArrayOfCarrierCode' => '\\ArrayType\\ArrayOfCarrierCode',
            'CarrierCode' => '\\StructType\\CarrierCode',
            'ReservationInfo' => '\\StructType\\ReservationInfo',
            'Person' => '\\StructType\\Person',
            'Address' => '\\StructType\\Address',
            'ArrayOfContactInfo' => '\\ArrayType\\ArrayOfContactInfo',
            'ContactInfo' => '\\StructType\\ContactInfo',
            'ArrayOfPaymentMetaData' => '\\ArrayType\\ArrayOfPaymentMetaData',
            'PaymentMetaData' => '\\StructType\\PaymentMetaData',
            'ViewPNR' => '\\StructType\\ViewPNR',
            'ArrayOfAirline' => '\\ArrayType\\ArrayOfAirline',
            'Airline' => '\\StructType\\Airline',
            'ArrayOfLogicalFlight' => '\\ArrayType\\ArrayOfLogicalFlight',
            'LogicalFlight' => '\\StructType\\LogicalFlight',
            'ArrayOfPhysicalFlight' => '\\ArrayType\\ArrayOfPhysicalFlight',
            'PhysicalFlight' => '\\StructType\\PhysicalFlight',
            'ArrayOfCustomer' => '\\ArrayType\\ArrayOfCustomer',
            'Customer' => '\\StructType\\Customer',
            'ArrayOfAirlinePerson' => '\\ArrayType\\ArrayOfAirlinePerson',
            'AirlinePerson' => '\\StructType\\AirlinePerson',
            'ArrayOfSeatAssignment' => '\\ArrayType\\ArrayOfSeatAssignment',
            'SeatAssignment' => '\\StructType\\SeatAssignment',
            'ArrayOfSeatAttribute' => '\\ArrayType\\ArrayOfSeatAttribute',
            'SeatAttribute' => '\\StructType\\SeatAttribute',
            'ArrayOfCharge' => '\\ArrayType\\ArrayOfCharge',
            'Charge' => '\\StructType\\Charge',
            'ArrayOfReservationPaymentMap' => '\\ArrayType\\ArrayOfReservationPaymentMap',
            'ReservationPaymentMap' => '\\StructType\\ReservationPaymentMap',
            'ArrayOfBaggage' => '\\ArrayType\\ArrayOfBaggage',
            'Baggage' => '\\StructType\\Baggage',
            'ArrayOfOAFlight' => '\\ArrayType\\ArrayOfOAFlight',
            'OAFlight' => '\\StructType\\OAFlight',
            'ArrayOfOAFlightPerson' => '\\ArrayType\\ArrayOfOAFlightPerson',
            'OAFlightPerson' => '\\StructType\\OAFlightPerson',
            'ArrayOfPayment' => '\\ArrayType\\ArrayOfPayment',
            'ArrayOfHistory' => '\\ArrayType\\ArrayOfHistory',
            'History' => '\\StructType\\History',
            'ArrayOfComment' => '\\ArrayType\\ArrayOfComment',
            'Comment' => '\\StructType\\Comment',
            'ArrayOfGDSHistory' => '\\ArrayType\\ArrayOfGDSHistory',
            'GDSHistory' => '\\StructType\\GDSHistory',
            'ArrayOfReservationContact' => '\\ArrayType\\ArrayOfReservationContact',
            'ReservationContact' => '\\StructType\\ReservationContact',
            'ArrayOfVoucher' => '\\ArrayType\\ArrayOfVoucher',
            'Voucher' => '\\StructType\\Voucher',
            'ArrayOfCar' => '\\ArrayType\\ArrayOfCar',
            'Car' => '\\StructType\\Car',
            'ArrayOfHotel' => '\\ArrayType\\ArrayOfHotel',
            'Hotel' => '\\StructType\\Hotel',
            'ArrayOfPackage' => '\\ArrayType\\ArrayOfPackage',
            'Package' => '\\StructType\\Package',
            'ExceptionInformation.Exceptions' => '\\StructType\\ExceptionInformation_Exceptions',
            'ExceptionInformation.Exception' => '\\StructType\\ExceptionInformation_Exception',
            'ViewFormatted3DSecureInformation' => '\\StructType\\ViewFormatted3DSecureInformation',
            'ViewConvertedCurrencyInfo' => '\\StructType\\ViewConvertedCurrencyInfo',
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
        );
    }
}
