<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Add ServiceType
 * @subpackage Services
 */
class Add extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named AddVoucherToReservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\AddVoucherToReservation $parameters
     * @return \StructType\AddVoucherToReservationResponse|bool
     */
    public function AddVoucherToReservation(\StructType\AddVoucherToReservation $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->AddVoucherToReservation($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named AddPointsToReservation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\AddPointsToReservation $parameters
     * @return \StructType\AddPointsToReservationResponse|bool
     */
    public function AddPointsToReservation(\StructType\AddPointsToReservation $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->AddPointsToReservation($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\AddPointsToReservationResponse|\StructType\AddVoucherToReservationResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
