<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PointsPayments StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PointsPayments
 * @subpackage Structs
 */
class PointsPayments extends AbstractStructBase
{
    /**
     * The TransactionInfo
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\TransactionInfo
     */
    public $TransactionInfo;
    /**
     * The ReservationInfo
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\ReservationInfo
     */
    public $ReservationInfo;
    /**
     * The PointsPaymentList
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfAddPointsPayment
     */
    public $PointsPaymentList;
    /**
     * Constructor method for PointsPayments
     * @uses PointsPayments::setTransactionInfo()
     * @uses PointsPayments::setReservationInfo()
     * @uses PointsPayments::setPointsPaymentList()
     * @param \StructType\TransactionInfo $transactionInfo
     * @param \StructType\ReservationInfo $reservationInfo
     * @param \ArrayType\ArrayOfAddPointsPayment $pointsPaymentList
     */
    public function __construct(\StructType\TransactionInfo $transactionInfo = null, \StructType\ReservationInfo $reservationInfo = null, \ArrayType\ArrayOfAddPointsPayment $pointsPaymentList = null)
    {
        $this
            ->setTransactionInfo($transactionInfo)
            ->setReservationInfo($reservationInfo)
            ->setPointsPaymentList($pointsPaymentList);
    }
    /**
     * Get TransactionInfo value
     * @return \StructType\TransactionInfo|null
     */
    public function getTransactionInfo()
    {
        return $this->TransactionInfo;
    }
    /**
     * Set TransactionInfo value
     * @param \StructType\TransactionInfo $transactionInfo
     * @return \StructType\PointsPayments
     */
    public function setTransactionInfo(\StructType\TransactionInfo $transactionInfo = null)
    {
        $this->TransactionInfo = $transactionInfo;
        return $this;
    }
    /**
     * Get ReservationInfo value
     * @return \StructType\ReservationInfo|null
     */
    public function getReservationInfo()
    {
        return $this->ReservationInfo;
    }
    /**
     * Set ReservationInfo value
     * @param \StructType\ReservationInfo $reservationInfo
     * @return \StructType\PointsPayments
     */
    public function setReservationInfo(\StructType\ReservationInfo $reservationInfo = null)
    {
        $this->ReservationInfo = $reservationInfo;
        return $this;
    }
    /**
     * Get PointsPaymentList value
     * @return \ArrayType\ArrayOfAddPointsPayment|null
     */
    public function getPointsPaymentList()
    {
        return $this->PointsPaymentList;
    }
    /**
     * Set PointsPaymentList value
     * @param \ArrayType\ArrayOfAddPointsPayment $pointsPaymentList
     * @return \StructType\PointsPayments
     */
    public function setPointsPaymentList(\ArrayType\ArrayOfAddPointsPayment $pointsPaymentList = null)
    {
        $this->PointsPaymentList = $pointsPaymentList;
        return $this;
    }
}
